"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _catalog = _interopRequireDefault(require("../catalog"));

var _catalogContext = _interopRequireDefault(require("./catalog-context"));

var _useCatalog = _interopRequireDefault(require("./use-catalog"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const CatalogProvider = props => {
  const {
    catalog,
    catalogPrefix,
    children
  } = props;
  const {
    catalog: outerCatalog
  } = (0, _useCatalog.default)() || {};
  let prefixedCatalog = null;

  if (catalogPrefix && catalog._components) {
    const components = {};
    Object.keys(catalog._components).forEach(c => {
      components[`${catalogPrefix}${c}`] = catalog._components[c];
    });
    prefixedCatalog = new _catalog.default({
      components
    });
  }

  let prepCatalog = prefixedCatalog || catalog || new _catalog.default({
    components: {}
  });

  if (outerCatalog) {
    prepCatalog = new _catalog.default({
      components: _objectSpread({}, outerCatalog && outerCatalog._components, {}, prepCatalog && prepCatalog._components)
    });
  }

  return _react.default.createElement(_catalogContext.default.Provider, {
    value: {
      catalog: prepCatalog
    }
  }, _react.default.Children.only(children));
};

CatalogProvider.defaultProps = {
  catalogPrefix: '',
  catalog: new _catalog.default({
    components: {}
  })
};
var _default = CatalogProvider;
exports.default = _default;